Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 384 by niro, Mon Jul 17 20:44:44 2006 UTC revision 891 by niro, Tue Aug 4 19:51:42 2009 UTC
# Line 4  Line 4 
4  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
5    
6  # SMAGE2  # SMAGE2
7  # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.43 2006-07-17 20:44:44 niro Exp $  # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.62 2007-11-28 10:47:50 niro Exp $
8    
9  #01.10.2004  #01.10.2004
10  # added ccache support  # added ccache support
11  # added distcc support  # added distcc support
12    
13    # set default user mage.rc
14    : ${MAGERC="/etc/mage.rc"}
15    
16  ## setup ##  ## setup ##
17  PKGSUFFIX="mpk"  PKGSUFFIX="mpk"
18    SRCPKGSUFFIX="mpks"
19  SMAGENAME="$1"  SMAGENAME="$1"
20  SMAGESUFFIX="smage2"  SMAGESUFFIX="smage2"
21  MLIBDIR=/usr/lib/mage  MLIBDIR=/usr/lib/mage
22  SMAGEVERSION="$( < ${MLIBDIR}/version)"  SMAGEVERSION="$( < ${MLIBDIR}/version)"
23    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
24    
25    
26  ## only for tests -> normally in /etc/rc.d/init.d/functions  ## only for tests -> normally in /etc/rc.d/init.d/functions
27  COLRED="\033[1;6m\033[31m"  COLRED="\033[1;6m\033[31m"
# Line 44  fi Line 50  fi
50  # export default C locale  # export default C locale
51  export LC_ALL=C  export LC_ALL=C
52    
53  source /etc/mage.rc  source /etc/mage.rc.global
54    source ${MAGERC}
55    
56  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # set PKGDIR and BUILDDIR and BINDIR to MROOT
57  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
# Line 63  showversion() Line 70  showversion()
70  die()  die()
71  {  {
72   xtitleclean   xtitleclean
73     echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}
74   echo "SMAGE failed: $@"   echo "SMAGE failed: $@"
75   exit 1   exit 1
76  }  }
# Line 91  syncsmage2() Line 99  syncsmage2()
99   local i   local i
100   for i in ${SMAGE2RSYNC}   for i in ${SMAGE2RSYNC}
101   do   do
102   rsync \   rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
103   if [[ $? = 0 ]]   if [[ $? = 0 ]]
104   then   then
105   break   break
106   else   else
107   continue   continue
108   fi   fi
   
109   done   done
110    
111   # clean up backup files (foo~)   # clean up backup files (foo~)
# Line 158  download_sources() Line 151  download_sources()
151   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )
152   if [[ $? = 0 ]]   if [[ $? = 0 ]]
153   then   then
154   # md5's ok, not fetching needed   # md5's ok, no fetching needed
155   FETCHING=false   FETCHING=false
156   else   else
157   FETCHING=true   FETCHING=true
# Line 180  download_sources() Line 173  download_sources()
173   my_SOURCEDIR="${SOURCEDIR}/${PNAME}"   my_SOURCEDIR="${SOURCEDIR}/${PNAME}"
174   fi   fi
175    
176     # create the SOURCEDIR
177     install -d ${my_SOURCEDIR}
178    
179   # if an mirrored file than replace first the mirror uri   # if an mirrored file than replace first the mirror uri
180   if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]   if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]
181   then   then
182   for mirror in ${MIRRORS}   for mirror in ${MIRRORS}
183   do   do
# Line 189  download_sources() Line 185  download_sources()
185    
186   if [[ ${FETCHING} = true ]]   if [[ ${FETCHING} = true ]]
187   then   then
188   echo "==> fetching ${my_SRC_URI_MIRROR}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
189     wget \
190     --passive-ftp \
191     --tries 3 \
192     --continue \
193     --progress bar \
194     --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
195     "${my_SRC_URI_MIRROR}"
196     if [[ $? = 0 ]]
197     then
198     break
199     else
200     continue
201     fi
202     fi
203     done
204     elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]
205     then
206     for mirror in ${SOURCEFORGE_MIRRORS}
207     do
208     my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"
209    
210     if [[ ${FETCHING} = true ]]
211     then
212     echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
213     wget \
214     --passive-ftp \
215     --tries 3 \
216     --continue \
217     --progress bar \
218     --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
219     "${my_SRC_URI_MIRROR}"
220     if [[ $? = 0 ]]
221     then
222     break
223     else
224     continue
225     fi
226     fi
227     done
228     elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]
229     then
230     for mirror in ${GNU_MIRRORS}
231     do
232     my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"
233    
234     if [[ ${FETCHING} = true ]]
235     then
236     echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
237   wget \   wget \
238   --passive-ftp \   --passive-ftp \
239   --tries 3 \   --tries 3 \
240   --continue \   --continue \
241   --progress bar \   --progress bar \
242   --directory-prefix="${my_SOURCEDIR}" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
243     "${my_SRC_URI_MIRROR}"
244     if [[ $? = 0 ]]
245     then
246     break
247     else
248     continue
249     fi
250     fi
251     done
252     elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]
253     then
254     for mirror in ${KDE_MIRRORS}
255     do
256     my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"
257    
258     if [[ ${FETCHING} = true ]]
259     then
260     echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
261     wget \
262     --passive-ftp \
263     --tries 3 \
264     --continue \
265     --progress bar \
266     --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
267     "${my_SRC_URI_MIRROR}"
268     if [[ $? = 0 ]]
269     then
270     break
271     else
272     continue
273     fi
274     fi
275     done
276     elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]
277     then
278     for mirror in ${GNOME_MIRRORS}
279     do
280     my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"
281    
282     if [[ ${FETCHING} = true ]]
283     then
284     echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
285     wget \
286     --passive-ftp \
287     --tries 3 \
288     --continue \
289     --progress bar \
290     --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
291   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
292   if [[ $? = 0 ]]   if [[ $? = 0 ]]
293   then   then
# Line 208  download_sources() Line 300  download_sources()
300   else   else
301   if [[ ${FETCHING} = true ]]   if [[ ${FETCHING} = true ]]
302   then   then
303   echo "==> fetching ${my_SRC_URI}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"
304   wget \   wget \
305   --passive-ftp \   --passive-ftp \
306   --tries 3 \   --tries 3 \
307   --continue \   --continue \
308   --progress bar \   --progress bar \
309   --directory-prefix="${my_SOURCEDIR}" \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \
310   "${my_SRC_URI}"   "${my_SRC_URI}"
311   fi   fi
312   fi   fi
# Line 228  download_sources() Line 320  download_sources()
320    
321   # recheck md5 sums   # recheck md5 sums
322   echo   echo
323   echo ">== Checking MD5 sums:"   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
324   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"
325   echo   echo
326    
# Line 275  mconfigure() Line 367  mconfigure()
367   ./configure \   ./configure \
368   --prefix=/usr \   --prefix=/usr \
369   --host=${CHOST} \   --host=${CHOST} \
370     --build=${CHOST} \
371   --mandir=/usr/share/man \   --mandir=/usr/share/man \
372   --infodir=/usr/share/info \   --infodir=/usr/share/info \
373   --datadir=/usr/share \   --datadir=/usr/share \
# Line 318  munpack() Line 411  munpack()
411    
412   SRCFILE=$1   SRCFILE=$1
413    
414   if [ -z "$2" ]   if [[ -z $2 ]]
415   then   then
416   DEST=${BUILDDIR}   DEST=${BUILDDIR}
417   else   else
418   DEST=$2   DEST=$2
419   fi   fi
420    
421     [[ ! -d ${DEST} ]] && install -d ${DEST}
422    
423   case "${SRCFILE##*.}" in   case "${SRCFILE##*.}" in
424   bz2)   bz2)
425   IFTAR="$(basename $SRCFILE .bz2)"   IFTAR="$(basename $SRCFILE .bz2)"
426   IFTAR="${IFTAR##*.}"   IFTAR="${IFTAR##*.}"
427   if [[ ${IFTAR} = tar ]]   if [[ ${IFTAR} = tar ]]
428   then   then
429   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."
430     else
431     pushd ${DEST} > /dev/null
432     bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."
433     popd > /dev/null
434   fi   fi
435   ;;   ;;
436   gz)   gz)
# Line 339  munpack() Line 438  munpack()
438   IFTAR="${IFTAR##*.}"   IFTAR="${IFTAR##*.}"
439   if [[ ${IFTAR} = tar ]]   if [[ ${IFTAR} = tar ]]
440   then   then
441   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."
442     else
443     pushd ${DEST} > /dev/null
444     zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."
445     popd > /dev/null
446   fi   fi
447   ;;   ;;
448   tbz2)   tbz2|mpks|mpk)
449   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
450   ;;   ;;
451   tgz)   tgz)
452   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
453     ;;
454     rar)
455     unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."
456     ;;
457     zip|xpi)
458     unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
459     ;;
460     rpm)
461     pushd ${DEST} > /dev/null
462     rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."
463     tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."
464     if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]
465     then
466     rm ${DEST}/${SRCFILE/.rpm/.tar.gz}
467     fi
468   ;;   ;;
469   *)   *)
470   die "munpack failed"   die "munpack failed"
# Line 358  mpatch() Line 476  mpatch()
476  {  {
477   local PATCHOPTS   local PATCHOPTS
478   local PATCHFILE   local PATCHFILE
479     local i
480    
481   PATCHOPTS=$1   PATCHOPTS=$1
482   PATCHFILE=$2   PATCHFILE=$2
483    
484     if [[ -z $2 ]]
485     then
486     PATCHFILE=$1
487    
488     ## patch level auto-detection, get patch level
489     for ((i=0; i < 10; i++))
490     do
491     patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null
492     if [[ $? = 0 ]]
493     then
494     PATCHOPTS="-Np${i}"
495     break
496     fi
497     done
498     fi
499    
500   echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"   echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"
501   patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}   patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}
502  }  }
503    
504    mlibtoolize()
505    {
506     local opts="$@"
507     [[ -z ${opts} ]] && opts="--copy --force"
508    
509     libtoolize ${opts} || die "running: mlibtoolize ${opts}"
510    }
511    
512  minstalldocs()  minstalldocs()
513  {  {
# Line 420  setup_distcc_environment() Line 562  setup_distcc_environment()
562  {  {
563   if [ -x /usr/bin/distcc ]   if [ -x /usr/bin/distcc ]
564   then   then
565   echo "Using DistCC for compilation ..."   echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"
566   export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"   export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"
567    
568   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"
# Line 435  setup_ccache_environment() Line 577  setup_ccache_environment()
577  {  {
578   if [ -x /usr/bin/ccache ]   if [ -x /usr/bin/ccache ]
579   then   then
580   echo "Using CCache for compilation ..."   echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"
581   export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"
582   fi   fi
583  }  }
# Line 459  fix_mage_deps() Line 601  fix_mage_deps()
601   # fix DEPEND   # fix DEPEND
602   while read sym dep   while read sym dep
603   do   do
604     # ignore empty lines
605     [[ -z ${dep} ]] && continue
606    
607   cat="$(dirname ${dep})"   cat="$(dirname ${dep})"
608   # change if not virtual   # change if not virtual
609   if [[ ${cat} = virtual ]]   if [[ ${cat} = virtual ]]
# Line 511  EOF Line 656  EOF
656  # special tags:  # special tags:
657  #   PKGTYPE               type of pkg  #   PKGTYPE               type of pkg
658  #   INHERITS              which functions get included  #   INHERITS              which functions get included
659  #   SPECIAL_FUNCTIONS     special functions wich should also be added  #   SPECIAL_FUNCTIONS     special functions which should also be added
660  #                         warning: they get killed before the build starts !  #                         warning: they get killed before the build starts !
661  #  #
662  #   MAGE_TREE_DEST        target destination of the generated tree  #   MAGE_TREE_DEST        target destination of the generated tree
# Line 539  build_mage_script() Line 684  build_mage_script()
684   dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"   dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"
685    
686   # show what we are doing   # show what we are doing
687   echo "Generating Mage file:"   echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"
688   echo "  ${dest}"   echo "${dest}"
689    
690   install -d "$(dirname ${dest})"   install -d "$(dirname ${dest})"
691   # now build the mage file   # now build the mage file
692   > ${dest}   > ${dest}
693    
694   # header   # header
695   echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.43 2006-07-17 20:44:44 niro Exp $' >> ${dest}   echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.62 2007-11-28 10:47:50 niro Exp $' >> ${dest}
696   echo  >> ${dest}   echo  >> ${dest}
697    
698   # pgkname and state   # pgkname and state
# Line 655  regen_mage_tree() Line 800  regen_mage_tree()
800   # now unset all uneeded vars to be safe   # now unset all uneeded vars to be safe
801   # unset PKGNAME <-- don't do that; smage needs this var   # unset PKGNAME <-- don't do that; smage needs this var
802   # unset to be safe (quotes needed !)   # unset to be safe (quotes needed !)
803   for i in ${SPECIAL_FUNCTIONS}  # for i in ${SPECIAL_FUNCTIONS}
804   do  # do
805   unset "${i}"  # unset "${i}"
806   done  # done
807   unset SPECIAL_FUNCTIONS   unset SPECIAL_FUNCTIONS
808   for i in ${SPECIAL_VARS}  # for i in ${SPECIAL_VARS}
809   do  # do
810   unset "${i}"  # unset "${i}"
811   done  # done
812   unset SPECIAL_VARS   unset SPECIAL_VARS
813   unset STATE   unset STATE
814   unset DESCRIPTION   unset DESCRIPTION
# Line 740  generate_package_md5sum() Line 885  generate_package_md5sum()
885   # fix target as it may be empty !   # fix target as it may be empty !
886   [ -n "${target}" ] && target="-${target}"   [ -n "${target}" ] && target="-${target}"
887    
888    
889   # build pkgname   # build pkgname
890   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"
891    
892   # build pkg-md5-sum only if requested   # build pkg-md5-sum only if requested
893   if [[ ${REGEN_MAGE_TREE} = true ]]   if [[ ${REGEN_MAGE_TREE} = true ]]
894   then   then
895   echo -n "Generating a md5sum for ${pkgname}.${PKGSUFFIX} ... "   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
896    
897   # abort if not exist   # abort if not exist
898   if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]   if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]
899   then   then
900   echo "! exists"   echo -e "${COLRED}! exists${COLDEFAULT}"
901   return 0   return 0
902   fi   fi
903    
# Line 759  generate_package_md5sum() Line 905  generate_package_md5sum()
905   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
906    
907   # setup md5 dir   # setup md5 dir
908   dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"   dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"
909   install -d ${dest}   install -d ${dest}
910    
911   # gen md5sum   # gen md5sum
912   ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \   ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \
913   > ${dest}/${pkgname}.md5   > ${dest}/${pkgname}.md5
914   echo "done"   echo -e "${COLGREEN}done${COLDEFAULT}"
915   fi   fi
916  }  }
917    
918    source_pkg_build()
919    {
920     if [[ ${PKGTYPE} = virtual ]]
921     then
922     echo "Virtual package detected; src-pkg-tarball not necessary ..."
923     return 0
924     fi
925    
926     if [[ ! -d ${SOURCEDIR}/${PNAME} ]]
927     then
928     echo "No SRC_URI defined; src-pkg-tarball not necessary ..."
929     return 0
930     fi
931    
932     [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."
933    
934     echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"
935    
936     # include the smage2 file
937     cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}
938    
939     ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )
940     [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}
941     mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}
942    
943     echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"
944    }
945    
946    step_by_step()
947    {
948     if [[ ${STEP_BY_STEP} = true ]]
949     then
950     echo "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
951     echo "Press [enter] to continue"
952     read
953     fi
954    }
955    
956    
957  # print out our version  # print out our version
958  showversion  showversion
959  echo  echo
# Line 888  then Line 1073  then
1073    
1074   regen_mage_tree   regen_mage_tree
1075    
1076   # build md5sum for existing packages   # build several targets
1077   generate_package_md5sum \   if [ -n "${MAGE_TARGETS}" ]
1078   --pcat "${PCATEGORIE}" \   then
1079   --pname "${PNAME}" \   for target in ${MAGE_TARGETS}
1080   --pver "${PVER}" \   do
1081   --pbuild "${PBUILD}" \   # build md5sum for existing packages
1082   --parch "${ARCH}" \   generate_package_md5sum \
1083   --target "${target}"   --pcat "${PCATEGORIE}" \
1084     --pname "${PNAME}" \
1085     --pver "${PVER}" \
1086     --pbuild "${PBUILD}" \
1087     --parch "${ARCH}" \
1088     --target "${target}"
1089     done
1090     else
1091     # build md5sum for existing packages
1092     generate_package_md5sum \
1093     --pcat "${PCATEGORIE}" \
1094     --pname "${PNAME}" \
1095     --pver "${PVER}" \
1096     --pbuild "${PBUILD}" \
1097     --parch "${ARCH}" \
1098     --target "${target}"
1099     fi
1100    
1101     exit 0
1102    fi
1103    
1104    if [ "$1" == "--create-src-tarball" -a -n "$2" ]
1105    then
1106     # set correct SMAGENAME
1107     SMAGENAME="$2"
1108     MD5DIR="$(dirname ${SMAGENAME})/md5"
1109    
1110     echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
1111    
1112     source ${SMAGENAME} || die "regen: smage2 not found"
1113    
1114     if [[ -d ${SOURCEDIR}/${PNAME} ]]
1115     then
1116     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
1117     rm -rf ${SOURCEDIR}/${PKGNAME}
1118     fi
1119    
1120     download_sources
1121     source_pkg_build ${SMAGENAME}
1122   exit 0   exit 0
1123  fi  fi
1124    
1125    if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
1126    then
1127     SRCPKGTARBALL="${2}"
1128     USE_SRC_PKG_TARBALL=true
1129    
1130     # abort if given file is not a source pkg
1131     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
1132    
1133     # set correct SMAGENAME; use the one that the src_pkg provide
1134     # /path/to/SOURCEDIR/PNAME/SMAGENAME
1135     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
1136    
1137     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
1138    
1139     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
1140    
1141     # unpack srctarball
1142     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
1143    
1144     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
1145    
1146     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
1147    fi
1148    
1149    
1150  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
1151  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
1152   die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."   die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
1153  [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your mage.rc correctly."  [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
1154  [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."  [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
1155  [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
1156  [ -z "${BINDIR}" ] && die "no BINDIR variable found in /etc/mage.rc"  [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
1157  [ -z "${CHOST}" ] && die "no CHOST variable found in /etc/mage.rc"  [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
1158  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in /etc/mage.rc"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
1159  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in /etc/mage.rc"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
1160    
1161  source ${SMAGENAME} || die "source failed"  source ${SMAGENAME} || die "source failed"
1162  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"
1163  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
1164    
1165  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
1166  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
1167    
1168  # auto regen mage tree if requested  # auto regen mage tree if requested
1169  regen_mage_tree  regen_mage_tree
1170    
1171    if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]
1172    then
1173     if [[ -d ${SOURCEDIR}/${PNAME} ]]
1174     then
1175     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
1176     rm -rf ${SOURCEDIR}/${PNAME}
1177     fi
1178    fi
1179    
1180  # download sources  # download sources
1181  download_sources  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources
1182    
1183  # fixes some issues with these functions  # fixes some issues with these functions
1184  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
# Line 979  then Line 1235  then
1235   mage rmstamp   mage rmstamp
1236  fi  fi
1237    
1238  src_prepare || die "src_prepare failed"  # setup build loggins
1239  src_compile || die "src_compile failed"  [[ ! -d /var/log/smage ]] && install -d /var/log/smage
1240  src_install || die "src_install failed"  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
1241    
1242    src_prepare || die "src_prepare failed" | ${SMAGE_LOG_CMD}
1243    step_by_step $_
1244    src_compile || die "src_compile failed" | ${SMAGE_LOG_CMD}
1245    step_by_step $_
1246    src_install || die "src_install failed" | ${SMAGE_LOG_CMD}
1247    step_by_step $_
1248    
1249    
1250  # compressing doc, info & man files  # compressing doc, info & man files
 echo -e "Compressing man-pages ..."  
1251  if [ -d ${BUILDDIR}/builded/usr/share/man ]  if [ -d ${BUILDDIR}/builded/usr/share/man ]
1252  then  then
1253     echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
1254   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man
1255  fi  fi
1256    
 echo -e "Compressing info-pages ..."  
1257  if [ -d ${BUILDDIR}/builded/usr/share/info ]  if [ -d ${BUILDDIR}/builded/usr/share/info ]
1258  then  then
1259     echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
1260   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info
1261  fi  fi
1262    
# Line 1003  case ${NOSTRIP} in Line 1266  case ${NOSTRIP} in
1266   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   echo -e "NOSTRIP=true detected; Package will not be stripped ..."
1267   ;;   ;;
1268   *)   *)
1269   echo -e "Stripping binaries ..."   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
1270   mstripbins ${BINDIR}   mstripbins ${BINDIR}
1271   echo -e "Stripping libraries ..."   echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"
1272   mstriplibs ${BINDIR}   mstriplibs ${BINDIR}
1273   ;;   ;;
1274  esac  esac
# Line 1041  case ${NOPKGBUILD} in Line 1304  case ${NOPKGBUILD} in
1304   --parch "${ARCH}" \   --parch "${ARCH}" \
1305   --target "${target}"   --target "${target}"
1306    
1307   echo -e "\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1308   done   done
1309   else   else
1310   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
# Line 1054  case ${NOPKGBUILD} in Line 1317  case ${NOPKGBUILD} in
1317   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
1318   --parch "${ARCH}"   --parch "${ARCH}"
1319    
1320   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
1321   fi   fi
1322    
1323     # build src-pkg-tarball if requested
1324     [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}
1325   ;;   ;;
1326  esac  esac
1327    
1328    if [[ ${SMAGE_BUILD_LOGGING} != false ]]
1329    then
1330     bzip2 -9f /var/log/smage/${PKGNAME}.log
1331    else
1332     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
1333    fi
1334    
1335  # for sure  # for sure
1336  unset NOPKGBUILD  unset NOPKGBUILD
1337  unset NOSTRIP  unset NOSTRIP

Legend:
Removed from v.384  
changed lines
  Added in v.891